/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
/* Courtesy of Cheqmate
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Ʃ
  						GC_Dvd.c										 
  																		 
  				based on dvd.c by  Peter (www.console-dev.de)   		 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [Description]....:  dvd interface access methods						 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [Notes......]....: 													 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [History....]....:  [bc]-12.10.2004 file created   					 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Ʃ
*/
#include "main.h"
#include "menu/menu.h"
#include <pad.h>
#include <font.h>
#include "dvd.h"
#include <GC_Dvd.h>
#include <linux/string.h>
#include <types.h>
extern volatile long* dvd;
/*  				DVD DEBUG MODE LIBRARY  			  */
void dvd_SetExtension()
{
	dvd[0] = 0x2E;
	dvd[1] = 0;

	dvd[2] = 0x55010000;
	dvd[3] = 0;
	dvd[4] = 0;
	dvd[5] = 0;
	dvd[6] = 0;
	dvd[7] = 1; // enable reading!
	while (dvd[7] & 1);
}

void dvd_setstatus()
{
	dvd[0] = 0x2E;
	dvd[1] = 0;

	dvd[2] = 0xee060300;
	dvd[3] = 0;
	dvd[4] = 0;
	dvd[5] = 0;
	dvd[6] = 0;
	dvd[7] = 1; // enable reading!
	while (dvd[7] & 1);
}

#define DEBUG_STOP_DRIVE 0
#define DEBUG_START_DRIVE 0x100
#define DEBUG_ACCEPT_COPY 0x4000
#define DEBUG_DISC_CHECK 0x8000
void dvd_motor_on_extra()
{
	dvd[0] = 0x2e;
	dvd[1] = 1;
	dvd[2] = 0xfe110100;
	dvd[3] = 0;
	dvd[4] = 0;
	dvd[5] = 0;
	dvd[6] = 0;
	dvd[7] = 1;
	while (dvd[7] & 1);
}
void dvd_unlock()
{
	dvd[0] |= 0x00000014;
	dvd[1] = 0;
	dvd[2] = 0xFF014D41;
	dvd[3] = 0x54534849;
	dvd[4] = 0x54410200;
	dvd[7] = 1;
	while ((dvd[0] & 0x14) == 0)
	{
	}
	dvd[0] |= 0x00000014;
	dvd[1] = 0;
	dvd[2] = 0xFF004456;
	dvd[3] = 0x442D4741;
	dvd[4] = 0x4D450300;
	dvd[7] = 1;
	while ((dvd[0] & 0x14) == 0)
	{
	}
}

u32 DVD_Status1()
{
	return R_DVD_STATUS_1;
}

u32 DVD_Status2()
{
	return R_DVD_STATUS_2;
}

u32 DVD_GetError()
{
	return R_DVD_ERRORCODE;
}

void DVD_RequestError()
{
	R_DVD_COMMAND = DVD_COMMAND_REQUESTERROR;
	R_DVD_ACTION = 1;
}

void DVD_Stop()
{
	R_DVD_COMMAND = DVD_COMMAND_STOP;
	R_DVD_ACTION = 1;
}

void DVD_AudioEnable()
{
	R_DVD_COMMAND = DVD_COMMAND_AUDIOENABLE; 
	R_DVD_ACTION = 1;
}


int DVD_WaitImmediate()
{
	u32 nCount = 0;

	while ((dvd[7] & 1))
	{
		if (++nCount > 0xFFFF)
		{
			return 0;
		}
	}

	return 1;
}

int DVD_CustomDbgCommand(u32 dwCommand, u32 dwOffset, u32 dwLength)
{
	dvd[0] = 0x10;
	dvd[1] = 0;

	dvd[2] = dwCommand;

	dvd[3] = dwOffset;
	dvd[4] = dwLength;

	dvd[7] = 1;

	DVD_WaitImmediate();

	if (dvd[0] & 0x04)
	{
		return 1;
	}

	return 0;
}

u32 DVD_ReadDriveMemDword(u32 dwAddress)
{
	dvd[0] = 0x14;
	dvd[1] = 0;
	dvd[2] = 0xFE010000;	
	dvd[3] = dwAddress;
	dvd[4] = 0x00010000;	
	dvd[8] = 0;
	dvd[7] = 1;

	if (DVD_WaitImmediate() == 1)
	{
		return dvd[8];
	}
	return 0xDDDDDDDD;
}

int DVD_ReadDriveMemBlock(u32 dwAddress, void* pData, u32 dwSize)
{
	u32* pSource = (u32*)pData;
//	u32 dwDest = dwAddress;
	int nLeft = dwSize;

	while (nLeft > 0)
	{
		*pSource++ = DVD_ReadDriveMemDword(dwAddress);
		dwAddress += 4;
		nLeft -= 4;
	}
	return 0;
}

void CMD_ExecuteDriveCodeCommand(u32 dwCmd)
{
	// set drivecode command byte
	DVD_WriteDriveMemDword(0x8504, dwCmd);
} 

int DVD_WriteDriveMemBlock(u32 dwAddress, void* pData, u32 dwSize)
{
	u32* pSource = (u32*)pData;
//	u32 dwDest = dwAddress;
	int nLeft = dwSize;

	while (nLeft > 0)
	{
		DVD_WriteDriveMemDword(dwAddress, *pSource++);
		dwAddress += 4;
		nLeft -= 4;
	}
	return 0;
}

int DVD_WriteDriveMemDwordN(u32 dwAddress, u32 dwData)
{
//	int nCount = 0;

	dvd[0] = 0x2e;
	dvd[1] = 0;
	dvd[2] = 0xFE010100;	

	dvd[3] = dwAddress;
	dvd[4] = 0x00040000;	
	dvd[5] = 0;
	dvd[6] = 0;
	dvd[7] = 3;

	while ((dvd[7] & 1))
	{
	}

	if (!(dvd[0] & 4))
	{
		return 1;
	}



	dvd[0] = 0x2e;
	dvd[1] = 0;
	dvd[2] = dwData;
	dvd[7] = 1;

	DVD_WaitImmediate();

	return 0;
}

int DVD_WriteDriveMemDword(u32 dwAddress, u32 dwData)
{
//	int nCount = 0;

	dvd[0] = 0x2e;
	dvd[1] = 0;
	dvd[2] = 0xFE010100;	

	dvd[3] = dwAddress;
	dvd[4] = 0x00040000;	
	dvd[5] = 0;
	dvd[6] = 0;
	dvd[7] = 3;

	DVD_WaitImmediate();

	dvd[0] = 0x2e;
	dvd[1] = 0;
	dvd[2] = dwData;
	dvd[7] = 1;

	DVD_WaitImmediate();

	return 0;
}

