/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#include "include/lowmem.h"//emukidid
#include "include/pad.h"//emukidid
#include "include/video.h"//emukidid
#include "include/dvd.h"//emukidid
#include "sram.h" //By VTrucco
#include "menu/menu.h"//By VTrucco
#include "menu/draw.h"
#include <linux/string.h>
#include <exception.h>
#include <console.h>
#include <vsprintf.h>
#include "main.h"//By VTrucco
#include <cache.h>
#include "GC_Dvd.h" //emukidid
#include <font.h>
#include <iso9660qoob.h>
#include <anaconda.h>
#include <setupdrive.h>
#include <fst.h>
#include <multigame.h>

extern void ANACONDA04(); // still calling it this for old times sake :P
//Video Stuff
extern u32* frameBuffer; //By VTrucco
extern void menu_redo(); // By VTrucco
char dvdid[6];
#define MEM_VIDEO_BASE  			 (0xCC002000)
#define GC_INIT_BASE			   	 (0x80000020)
typedef struct {
	u8  ConsoleID;		//G = Gamecube, R = Wii.
	u8  GamecodeA;		//2 Ascii letters to indicate the GameID.
	u8  GamecodeB;		//2 Ascii letters to indicate the GameID.
	u8	CountryCode;	//J=JAP . P=PAL . E=USA . D=OoT MasterQuest
	u8	MakerCodeA;		//Eg 08 = Sega etc.
	u8  MakerCodeB;
	u8	DiscID;
	u8	Version;
	u8	AudioStreaming; //01 = Enable it. 00 = Don't
	u8 	StreamBufSize;	//For the AudioEnable. (always 00?)
	u8	unused_1[18];	
	u32 DVDMagicWord;	//0xC2339F3D
	char GameName[992];	//String Name of Game, rarely > 32 chars
	u32 DMonitorOffset;	//offset of debug monitor (dh.bin)?
	u32	DMonitorLoadAd;	//addr(?) to load debug monitor?
	u8	unused_2[24];	
	u32 DOLOffset;		//offset of main executable DOL (bootfile)
	u32 FSTOffset;		//offset of the FST ("fst.bin")
	u32	FSTSize;		//size of FST
	u32	MaxFSTSize;		//maximum size of FST (usually same as FSTSize)*
	u32 UserPos;		//user position(?)
	u32 UserLength;		//user length(?)
	u32 unknown;		//(?)
	u32 unused_3;
}DVDINFO;

// A simple check to see if the drive is in a ready state
void dvdwait()
{
	DVD_RequestError();
	DVD_WaitImmediate();
	while (R_DVD_ACTION & 1);
}

int audio_setup()
{
	int y = 175;
	unsigned int oldOffset = 0x00000000;
	bool mg = false;
	PAD PAD;
	clearCentre();
	write_font(78,y,   "This Game Requires Audio to be setup!");
	write_font(78,y+26,"      To Enable it, press A");
	write_font(78,y+52,"       To Disable, Press B");

	while(1) {
		PAD_ReadState(&PAD, 0);
		if (PAD.Digital.A) {
			do{PAD_ReadState(&PAD, 0);}while(PAD.Digital.A);
			clearCentre();
			if(dvd_get_lba() != 0) { // If we're running a multigame or something
				oldOffset = dvd_get_lba();
				//printf("got old LBA: %08X\n",oldOffset);
				mg = true;
			}
			write_font(125,y,"Setting up Audio...");
			dvd_reset();
			dvd_read_id();
			if(mg) {
				dvd_set_lba(oldOffset);
				//printf("Setting offset! %08X\n",(oldOffset<<2));
			}
			enable_audio();
			return 0;
		}
		if (PAD.Digital.B)
		{
			do{PAD_ReadState(&PAD, 0);}while(PAD.Digital.B);
			return 0;
		}
	}
	
}

/*
Region Defaults - tmbinc
*/
void Set_Game_Videomode(int mode)
{
	static const u32 vi_Mode640X480NtscYUV16[32] = 
	{
		0x0F060001, 0x476901AD, 0x02EA5140, 0x00030018,	0x00020019, 0x410C410C, 0x40ED40ED, 0x00435A4E,	0x00000000, 0x00435A4E, 0x00000000, 0x00000000,	0x110701AE, 0x10010001, 0x00010001, 0x00010001,	0x00000000, 0x00000000, 0x28500100, 0x1AE771F0,	0x0DB4A574, 0x00C1188E, 0xC4C0CBE2, 0xFCECDECF,	0x13130F08, 0x00080C0F, 0x00FF0000, 0x00000000,	0x02800000, 0x000000FF, 0x00FF00FF, 0x00FF00FF
	};

	static const u32 vi_Mode640x480NtscProgressiveYUV16[32] = 
	{
		0x1e0c0005, 0x476901ad, 0x02ea5140, 0x00060030,	0x00060030, 0x81d881d8, 0x81d881d8, 0x10000000,	0x00000000, 0x00000000, 0x00000000, 0x037702b6,	0x90010001, 0x00000000, 0x00000000, 0x00000000,	0x00000000, 0x00000000, 0x28280100, 0x1ae771f0,	0x0db4a574, 0x00c1188e, 0xc4c0cbe2, 0xfcecdecf,	0x13130f08, 0x00080c0f, 0x00ff0000, 0x00010001,	0x02800000, 0x000000ff, 0x00ff00ff, 0x00ff00ff
	};

	static const u32 vi_Mode640X576Pal50YUV16[32] = 
	{
		0x11F50101, 0x4B6A01B0, 0x02F85640, 0x00010023,	0x00000024, 0x4D2B4D6D, 0x4D8A4D4C, 0x0066D480,	0x00000000, 0x0066D980, 0x00000000, 0x00C901F3,	0x913901B1, 0x90010001, 0x00010001, 0x00010001,	0x00000000, 0x00000000, 0x28500100, 0x1AE771F0,	0x0DB4A574, 0x00C1188E, 0xC4C0CBE2, 0xFCECDECF,	0x13130F08, 0x00080C0F, 0x00FF0000, 0x00000000,	0x02800000, 0x000000FF, 0x00FF00FF, 0x00FF00FF
	};

	static const u32 vi_Mode640X480Pal60YUV16[32] = 
	{
		0x0F060001, 0x476901AD, 0x02EA5140, 0x00030018,	0x00020019, 0x410C410C, 0x40ED40ED, 0x0066D480,	0x00000000, 0x0066D980, 0x00000000, 0x00C9010F,	0x910701AE, 0x90010001, 0x00010001, 0x00010001,	0x00000000, 0x00000000, 0x28500100, 0x1AE771F0,	0x0DB4A574, 0x00C1188E, 0xC4C0CBE2, 0xFCECDECF,	0x13130F08, 0x00080C0F, 0x00FF0000, 0x00000000,	0x02800000, 0x000000FF, 0x00FF00FF, 0x00FF00FF
	};
	if (mode == 0)
		memcpy((void*)MEM_VIDEO_BASE,vi_Mode640X480NtscYUV16,0x80); //ntsc
	if (mode == 1)
		memcpy((void*)MEM_VIDEO_BASE,vi_Mode640X576Pal50YUV16,0x80); //pal
	if (mode == 2)
		memcpy((void*)MEM_VIDEO_BASE,vi_Mode640X480Pal60YUV16,0x80); //pal60
	if (mode == 3)
		memcpy((void*)MEM_VIDEO_BASE,vi_Mode640x480NtscProgressiveYUV16,0x80); //480ntsc
}

/*
Initialization routine with the defaults
*/

void InitSystem(unsigned long VidMode)
{
	static u32 GC_DefaultConfig[64] =
	{
		0x0D15EA5E, 0x00000001, 0x01800000, 0x00000003, //  0.. 3 80000020
		0x00000000, 0x816FFFF0, 0x817FE8C0, 0x00000024, //  4.. 7 80000030
		0x00000000, 0x00000000, 0x00000000, 0x00000000, //  8..11 80000040
		0x00000000, 0x00000000, 0x00000000, 0x00000000, // 12..15 80000050
		0x38A00040, 0x7C6802A6, 0x9065000C, 0x80650008, // 16..19 80000060
		0x64638000, 0x7C6803A6, 0x38600030, 0x7C600124, // 20..23 80000070
		0x4E800020, 0x00000000, 0x00000000, 0x00000000, // 24..27 80000080
		0x00000000, 0x00000000, 0x00000000, 0x00000000, // 28..31 80000090
		0x00000000, 0x00000000, 0x00000000, 0x00000000, // 32..35 800000A0
		0x00000000, 0x00000000, 0x00000000, 0x00000000, // 36..39 800000B0
		0x015D47F8, 0xF8248360, 0x00000000, 0x00000001, // 40..43 800000C0
		0x00000000, 0x00000000, 0x00000000, 0x00000000, // 44..47 800000D0
		0x814B7F50, 0x815D47F8, 0x00000000, 0x81800000, // 48..51 800000E0
		0x01800000, 0x817FC8C0, 0x09A7EC80, 0x1CF7C580  // 52..55 800000F0
	};

	//Lets close Exceptions
	exception_close();

	if((VidMode == 0) || (VidMode == 0x45) || (VidMode == 0x4A)) { //Standard NTSC
		Set_Game_Videomode(0);
		GC_DefaultConfig[43] = 0;
	}
	if((VidMode == 1) || (VidMode == 0x50) || (VidMode == 0x55)) { //Standard PAL50
		Set_Game_Videomode(1);
		GC_DefaultConfig[43] = 1;
	}
	if(VidMode == 2) { //PAL60
		Set_Game_Videomode(2);
		GC_DefaultConfig[43] = 5;
	}
	if(VidMode == 3) { //480P
		Set_Game_Videomode(3);
		GC_DefaultConfig[43] = 0;
	}

	memcpy((void*)GC_INIT_BASE,GC_DefaultConfig,0xe0);
	dcache_flush((void*)0x80000000, 0x3100);
}

u32 tempOffset = 0;
extern long BNROffset;
void FinalizeBoot()
{
	PAD PAD;
	char tempStr[32];
	bool good = true;
	DVDINFO GCMDisk;
	
	dvd_read(&GCMDisk,sizeof(GCMDisk),0);
	if(GCMDisk.AudioStreaming == 0x01) //setup for audio streaming
		audio_setup();	
	dvd_read_id();
	clearCentre();
	showBanner(75, 120, 2);
	
	memset(tempStr,0,40);
	strncpy(tempStr, GCMDisk.GameName, 38);
	write_font(65, 189, tempStr);
	write_font(65, 215, TEMPBanner.shortDeve);
	
	write_font(65, 275, "- Game Video Mode Options -");
	write_font(65, 301, "Press: X for PAL   L for PAL60");
	write_font(65, 327, "       Y for NTSC  R for 480p");
	write_font(65, 353, "       A for Auto Detect");
	write_font(65, 379, "       B to Return to the menu");
	
	while (good)
	{	
		PAD_ReadState(&PAD, 0);
		
		if(dvd_get_error() >> 24 == 0x01)
			good = false;
		
		if (PAD.Digital.Y)
		{
			InitSystem(0); load_app(); break;
		}
		if (PAD.Digital.X)
		{
			InitSystem(1); load_app(); break;
		}
		if (PAD.Digital.L)
		{
			InitSystem(2); load_app(); break;
		}
		if (PAD.Digital.R)
		{
			InitSystem(3); load_app(); break;
		}
		if (PAD.Digital.A)
		{
			InitSystem(GCMDisk.CountryCode); load_app(); break;
		}
		if (PAD.Digital.B)
		{
			clearCentre();
			clearCentre(); menu_redo(); break;
		}
	} clearCentre(); menu_redo();

}




void ANACONDA04()
{
	PAD PAD;
	if (setupdrive())
	{
		clearCentre();
		dvdwait();
		dvd_read(dvdid, 6, 0);
		dvdwait();
		static unsigned char checkBuffer[5] __attribute__((aligned(32)));
		dvd_read(checkBuffer, 5, 32769);
	
		if (strncmp((const char*)dvdid, "COBRAM", 6) == 0)
			multiboot();
			
		else if ((strncmp((const char*)dvdid, "GGCOSD", 6) == 0) || (strncmp((const char*)dvdid, "GCOPDV", 6) == 0) || (strncmp((const char*)dvdid, "RGCOSD", 6) == 0))
			multiboot();
						
		else if ((strncmp((const char*)checkBuffer, "CD001", 8) == 0) && (strcmp((const char*)dvdid, "") == 0))
			isoHandler();
			
		else if ((strcmp((const char*)dvdid, "") == 0) && (!strncmp((const char*)checkBuffer, "\2CD001\1", 8) == 0)) {
			
			set_color(BACKGROUND_COLOR, COLOR_YELLOW);
			write_font(115, 194, "Media wasn't recognized!");
			write_font(115, 240, "Press A to return to menu..."); 
			write_font(115, 266, "Press Z to retry..."); 
			dvd_motor_off();
			
			while (1) {
				PAD_ReadState(&PAD, 0);
				if (PAD.Digital.A) {
					menuRefresh();
					break;
				}
				if (PAD.Digital.Z)	{
					clearCentre();
					ANACONDA04();
				}
			}
		}
		else
			FinalizeBoot(); //If not cobra disc, boot as normal.
	}
	else
	clearCentre();
}
