#include "include/video.h"
#include "include/dvd.h"
#include "cache.h"
#include "menu/menu.h"//By VTrucco
#include "GC_Dvd.h"
#include <anaconda.h>
#include <font.h>
#include "menu/draw.h"
#include <setupdrive.h>
#include <drivecodes.h>

int previouslyPatched = 0; 		//for GC

// Simple Delay based on 60Hz refresh rate
void GC_Sleep(u32 dwMiliseconds)
{
	int nVBlanks = (dwMiliseconds / 16);
	while (nVBlanks-- > 0)
	{
		video_wait_vsync();
	}
}

/*
DriveCode stuff, based on cheqmates loading routines and modified GC-linux drivecodes
*/
long InquiryBuf[8];
volatile long *io=(volatile long *)0xCC006000;

long drive_version()
{
        io[0] = 0x2e;
        io[1] = 0;
        io[2] = 0x12000000;
        io[3] = 0;
        io[4] = 0x20;
        io[5] = (long)InquiryBuf;
        io[6] = 0x20;
        io[7] = 3;

        while( io[7] & 1 );
        dcache_flush((void *)InquiryBuf, 0x20);
        
        return InquiryBuf[1];
}

void handleMods()
{
	write_font(115,266,"Disabling any modchips..");
	io[0] = 0x2e;
	io[1] = 0;
	io[2] = 0x25000000; //disable the XenoGC or DuoQ
	io[7] = 1;
	while (io[7] & 1);
	GC_Sleep(6000); //should be enough time for it to stop sending the credits binary

}

long dvd_get_status()
{
	io[2] = 0xE0000000;
	io[8] = 0;
	io[7] = 1;
	while (io[7] & 1);
	return io[8];
}

long dvd_get_lba()
{
	io[0] = 0x2E;
	io[1] = 0;
	io[2] = 0xD9010000;
	io[3] = 0;
	io[7] = 1;
	while (io[7] & 1);
	return io[8];
}

void enable_audio()
{
	io[0] = 0x2E;
	io[2] = 0xE4010000;
	io[7] = 1;
	while (io[7] & 1);
}

void dvd_set_lba(u32 lba)
{
	io[0] = 0x2E;
	io[1] = 0;
	io[2] = 0xD9000000;
	io[3] = lba;
	io[4] = 0;
	io[7] = 1;
	while (io[7] & 1);
}

void dvd_set_offset(u32 offset)
{
	io[0] = 0x2E;
	io[1] = 0;
	io[2] = 0xD9000000;
	io[3] = offset >> 2;
	io[4] = 0;
	io[7] = 1;
	while (io[7] & 1);
}

void dvd_set_offset_GC(u32 offset)
{
	io[0] = 0x2E;
	io[1] = 0;
	io[2] = 0x32000000;
	io[3] = offset >> 2;
	io[4] = 0;
	io[7] = 1;
	while (io[7] & 1);
}


void dvd_set_offsetDVD9(u32 offset)
{
	io[0] = 0x2E;
	io[1] = 0;
	io[2] = 0xD9000000;
	io[3] = offset;
	io[4] = 0;
	io[7] = 1;
	while (io[7] & 1);
}
void patchGCDrive(int drive)
{
	if(!previouslyPatched) 
	{
		dvd_unlock();
		handleMods();
		void *ptr;
		if(drive == 4)
			ptr = &Drive04;
		if(drive == 6)
			ptr = &Drive06;
		if(drive == 8)
			ptr = &Drive08;
		if(drive == 9)
			ptr = &DriveQ;	
		DVD_WriteDriveMemBlock(0xff40d000, ptr, 0x1F0);
		DVD_WriteDriveMemDword(0x804c, 0x00d04000);
		dvdwait();
		dvd_SetExtension();
		dvdwait();
	}
	dvd_unlock();
	dvdwait();
	dvd_motor_on_extra();
	dvdwait();
	dvd_setstatus();
	dvdwait();
	dvd_read_id();
	isGC = 1;		//We are on a GC!
	previouslyPatched = 1;	//we are patched for next time
}

bool checkDrive() {
	switch(drive_version()) {
		case 0x20010608:
			return true;
		case 0x20020402:
			return true;
		case 0x20020823:
			return true;
		case 0x20010831:
			return true;
		default:
		return false;
	}
}
			
/*
Check the drive model, then use the right patchcode
*/
bool setupdrive()
{
	char tempStra[20];
	long DriveDate = drive_version();
	bool knownDrive = false;
	clearCentre();
	
	if(DriveDate == 0x00000000) {	//something is wrong
		dvd_reset();
		DriveDate = drive_version();
	}
	isGC = checkDrive();
	if(isGC)
		dvd_set_offset_GC(0);
	if(!isGC)
		dvd_set_offset(0);
	dvd_read_id();
	if(dvd_get_status() == 0x00000000) //if a disc already is ok
		return true;
		
	if(DriveDate == 0x20060526)
		write_font(115,240,"GC2-DMS/D2A Drive Found!");
	if(DriveDate == 0x20060907)
		write_font(115,240,"GC2-D2B Drive Found!");
	if(DriveDate == 0x20010608)	{
		write_font(115,240,"GC-D2 B Drive Found!");
		patchGCDrive(6);
	}
	if(DriveDate == 0x20020402)	{
		write_font(115,240,"GC-D2 C Drive Found!");
		patchGCDrive(4);
	}
	if(DriveDate == 0x20020823)	{
		write_font(115,240,"GC-D2 D Drive Found!");
		patchGCDrive(8);
	}
	if(DriveDate == 0x20010831)	{
		write_font(115,240,"GC-D3 Drive Found!");
		patchGCDrive(9);
	}
		
	sprintf(tempStra,"Drive %08x OK!",DriveDate);
	write_font(115,200,tempStra);
	dvd_read_id();
	if(dvd_get_status() == 0x00000000)
		return true;
	dvd_reset();
	dvd_read_id();
	dvd_set_streaming();
	if(dvd_get_status() == 0x00000000)
		return true;
	return false; 
}
