#include <linux/string.h>
#include <exception.h>
#include <console.h>
#include <vsprintf.h>
#include "main.h"//By VTrucco
#include <cache.h>
#include "GC_Dvd.h" //emukidid
#include <font.h>
#include <iso9660qoob.h>
#include <setupdrive.h>
#include <pad.h>
#include <menu/draw.h>

#define MAX_GAMES 64
#define GCM_NAME_LEN 64

extern u32* frameBuffer;
int GamesFound = 0;
char gameNameTable[MAX_GAMES][GCM_NAME_LEN];
unsigned int gameOffsetTableTemp[MAX_GAMES];
unsigned int gameOffsetTable[MAX_GAMES];

void list_games(int a);
extern int read_safe(void* dst, int offset, int len);
extern unsigned int dvd_read64(void* dst, int len, unsigned int offset);
extern void FinalizeBoot();
extern void menu_redo();

int multiboot() //little parser which works with cobra and gcos multi's
{
	PAD pad;
	int i = 0;
	int numGames = 0;
	unsigned int aOffset;
	unsigned int isDVD9;
	unsigned int offset = 64;
	bool refreshList = true;
	char tmpGame[GCM_NAME_LEN];
	//char tmpStr[256];
	long long DVD9Offset;

	clearCentre();
	write_font(85, 194,"Filtering/Processing MultiGame list..");

	//check the header position 4 for the string DVD9
	read_safe(&isDVD9,4,4);
	if(isDVD9 == 0x44564439)
		isDVD9 = 1;
	else
		isDVD9 = 0;

	//Read in the whole table of offsets
	read_safe(&gameOffsetTableTemp, offset,MAX_GAMES*4);

	//Remove any useless entries that are not aligned (128k)
	for(i = 0; i<MAX_GAMES; i++)
	{
		if(isDVD9) //then make it an offset
		{
			if(!isGC)
			{
				DVD9Offset = gameOffsetTableTemp[i] << 2;
				if(((DVD9Offset % 0x20000) == 0) && (gameOffsetTableTemp[i] != 0))
				{
					gameOffsetTable[numGames] = gameOffsetTableTemp[i];
					numGames++;
				}
			}
			if(isGC) //GC can handle different boundary offsets but not past 1.35gb :)
			{
				if((gameOffsetTableTemp[i] != 0) && (gameOffsetTableTemp[i]<0x15C16000))
				{
					gameOffsetTable[numGames] = gameOffsetTableTemp[i];
					numGames++;
				}
			}
		}
		else
		{
			if(!isGC)
			{
				if(((gameOffsetTableTemp[i] % 0x00020000) == 0) && (gameOffsetTableTemp[i] != 0))
				{
					gameOffsetTable[numGames] = gameOffsetTableTemp[i];
					numGames++;
				}
			}
			if(isGC)		//GC can handle different boundary offsets :)
			{
				if(gameOffsetTableTemp[i] != 0)
				{
					gameOffsetTable[numGames] = gameOffsetTableTemp[i];
					numGames++;
				}
			}
		}
	}

	//Read all the game names
	for(i = 0; i<numGames; i++)
	{
		if(isDVD9)
			dvd_read64(&tmpGame,GCM_NAME_LEN,gameOffsetTable[i]+8);
		if(!isDVD9)
			read_safe(&tmpGame,gameOffsetTable[i]+32,GCM_NAME_LEN);
		strcpy(gameNameTable[i],tmpGame);
	}
	GamesFound = numGames;

	i = 0;
	list_games(i);
	if(numGames>0)
	{
		while (1)
		{
			PAD_ReadState(&pad, 0);
			if (pad.Digital.Up || (pad.Analog.Y < -50))
			{
				do{PAD_ReadState(&pad, 0);} while(pad.Digital.Up || (pad.Analog.Y < -50));
				if (i>0)
					list_games(--i);
			}
			if (pad.Digital.Down || (pad.Analog.Y > 50))
			{
				do{PAD_ReadState(&pad, 0);} while(pad.Digital.Down || (pad.Analog.Y > 50));
				if (i<numGames-1)
					list_games(++i);
			}
			if (pad.Digital.A || pad.Digital.Start)
			{
				do{	PAD_ReadState(&pad, 0);	}while (pad.Digital.A || pad.Digital.Start);
				clearCentre();
				if((isDVD9) && (!isGC))			//DVD9 created and in Wii
					dvd_set_offsetDVD9(gameOffsetTable[i]);
				if((isDVD9) && (isGC))			//DVD9 created and in GC
					dvd_set_offset_GC(gameOffsetTable[i]<<2);
				if((!isDVD9) && (!isGC))		//not DVD9 created and in Wii
					dvd_set_offset(gameOffsetTable[i]);
				if((!isDVD9) && (isGC))			//not DVD9 created and in GC
					dvd_set_offset_GC(gameOffsetTable[i]);

				FinalizeBoot(); //go to region selection process
				return 0;
			}
			if(pad.Digital.B) {
				do{PAD_ReadState(&pad, 0);} while(pad.Digital.B);
				menu_redo();
				return 0;
			}
		}
	}
	else
	{
		write_font(85, 194,"No Usable Entries Found!");
		GC_Sleep(1000);
		menu_redo();
	}
	return 0;
}

void list_games(int a)
{
	int x = 85;
	int y = 180;
	int i = 0;
	int selectedgame = a;
	int GamesPerPage = (GamesFound>8) ? 8 : GamesFound;
	char tmpStr[128];

	clearCentre();

	if ((selectedgame > GamesPerPage-2) && (selectedgame < GamesFound - 2))
		a = selectedgame - GamesPerPage + 2;
	else if (selectedgame <= GamesPerPage - 2)
		a = 0;
	else a = selectedgame - GamesPerPage + 1;

	sprintf(tmpStr,"Found %i Games (Press A)..",GamesFound);
	write_font(85, 124,tmpStr);

	for(i = a; i<a+GamesPerPage; i++)
	{
		if (i==selectedgame)
			drawHighlight(frameBuffer, 35, y+3,285);
		write_font(x,y,gameNameTable[i]);
		y+=24;
	}
}
