/*
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Ʃ
  						GC_Dvd.h										 
  																		 
  				based on libogc dvd.c by  Peter & Yursoft   			 
  																		 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [Description]....:  dvd interface access methods						 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [Notes......]....: 													 
  																		 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   [History....]....:  [bc]-12.10.2004 file created   					 
  																		 
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Ʃ
*/


/*+----------------------------------------------------------------------------------------------+*/
#ifndef GC_DVD_H
#define GC_DVD_H
/*+----------------------------------------------------------------------------------------------+*/
#include "../include/types.h"

/*+----------------------------------------------------------------------------------------------+*/
#define MEM_DVD_BASE					(0xCC006000)   ///< Memory address of the DVD Interface
/*+----------------------------------------------------------------------------------------------+*/
#define R_DVD_STATUS_1					/*dvd[00]*/ *(vu32*)(MEM_DVD_BASE)  	 ///< DVD status1 register
#define R_DVD_STATUS_2  				/*dvd[01]*/ *(vu32*)(MEM_DVD_BASE+0x04)  ///< DVD status2 register
#define R_DVD_COMMAND					/*dvd[02]*/ *(vu32*)(MEM_DVD_BASE+0x08)
#define R_DVD_SUBCOMMAND				/*dvd[02]*/ *(vu32*)(MEM_DVD_BASE+0x09)
#define R_DVD_SUBCOMMAND2				/*dvd[02]*/ *(vu32*)(MEM_DVD_BASE+0x0A)	
#define R_DVD_OFFSET					/*dvd[03]*/ *(vu32*)(MEM_DVD_BASE+0x0C)	
#define R_DVD_SOURCELENGTH				/*dvd[04]*/ *(vu32*)(MEM_DVD_BASE+0x10)		
#define R_DVD_DESTINATIONBUFFER			/*dvd[05]*/ *(vu32*)(MEM_DVD_BASE+0x14)		
#define R_DVD_DESTINATIONLENGTH			/*dvd[06]*/ *(vu32*)(MEM_DVD_BASE+0x18)		
#define R_DVD_ACTION					/*dvd[07]*/ *(vu32*)(MEM_DVD_BASE+0x1C)	
#define R_DVD_IMMBUF					/*dvd[08]*/ *(vu32*)(MEM_DVD_BASE+0x20)		
#define R_DVD_CONFIG					/*dvd[09]*/ *(vu32*)(MEM_DVD_BASE+0x24)	

#define R_DVD_ERRORCODE					R_DVD_IMMBUF

/*+----------------------------------------------------------------------------------------------+*/
// Implemented by Yursoft
/*+----------------------------------------------------------------------------------------------+*/
#define DVD_COMMAND_INQUIRY				(0x12000000)
#define DVD_COMMAND_STOP				(0xE3000000)
#define DVD_COMMAND_READ				(0xA8000000)
#define DVD_COMMAND_SEEK				(0xAB000000)
#define DVD_COMMAND_REQUESTERROR		(0xE0000000)
#define DVD_COMMAND_AUDIOSTREAM			(0xE1000000)
#define DVD_COMMAND_AUDIOSTATUS			(0xE2000000)
#define DVD_COMMAND_AUDIODISABLE		(0xE4000000)
#define DVD_COMMAND_AUDIOENABLE			(0xE4010000)
#define DVD_COMMAND_DBG_READMEM			(0xFE010000)

/*+----------------------------------------------------------------------------------------------+*/
#define DVD_STATE_COVER_OPEN			(0x05)  ///< It's internally used by DVD_IsCoverOpen()
/*+----------------------------------------------------------------------------------------------+*/
void GC_Sleep(u32 dwMiliseconds);
typedef struct
{
	u16 RevisionLevel;
	u16 DeviceCode;
	u32 ReleaseDate;
	u8 Padding[24];
} DVD_DRIVEINFO;


/*+----------------------------------------------------------------------------------------------+*/
#ifdef __cplusplus
extern "C"
{
#endif
	/*+----------------------------------------------------------------------------------------------+*/
	void dvd_unlock();
	void CMD_ExecuteDriveCodeCommand(u32 dwCmd);
	void readdiscid();
	//void	DVD_Init();
	void DVD_Reset();
	void DVD_Reset2();
	int DVD_ReadId(void* pDst);
	void DVD_Stop();
	int DVD_WaitImmediate();
	int DVD_Read(void* pDst, u32 dwBytes, u32 dwOffset);
	void DVD_ReadSector(s32 Sector, void* Buffer);
	void DVD_Seek(u32 Sector);
	void dvd_motor_on_extra();
	void dvd_setstatus();
	void dvd_SetExtension();
	void DVD_AudioEnable();
	void DVD_AudioDisable();
	u32 DVD_AudioStatus();
	void acondareset();
	void acondaunlockdrive();
	void acondasendcode();
	void acondaaudio();
	int DVD_CustomCommand(u32 dwCmd, void* pData, u32 dwSize, int bDataIn);
	int DVD_CustomCommandRaw(u32* pCmd);
	int DVD_CustomCommandImmediate(char* szCommand);

	int DVD_SetDebugMode();
	int DVD_SetDebugMode1();
	int DVD_SetDebugMode2();

	int DVD_StartDrive();
	int DVD_SetupDrive();

	u32 DVD_ReadDriveMemDword(u32 dwAddress);
	int DVD_ReadDriveMemBlock(u32 dwAddress, void* pData, u32 dwSize);
	int DVD_WriteDriveMemDword(u32 dwAddress, u32 dwData);
	int DVD_WriteDriveMemBlock(u32 dwAddress, void* pData, u32 dwSize);
	int DVD_Test();
	int DVD_CustomDbgCommand(u32 dwCommand, u32 dwOffset, u32 dwLength);
	int DVD_WriteDriveMemDwordN(u32 dwAddress, u32 dwData);
	int DVD_Inquiry(DVD_DRIVEINFO* DVDDriveInfo);
	void DVD_RequestError();

	u32 DVD_GetError();
	u32 DVD_Status1();
	u32 DVD_Status2();
	u8 DVD_IsCoverOpen(void);


	/*+----------------------------------------------------------------------------------------------+*/
	// Anaconda
	/*+----------------------------------------------------------------------------------------------+*/
	void DVD_SwapToDVDR();

	void DVD_Anaconda_Reset();
	void DVD_Anaconda_ReadDiscId();
	void DVD_Anaconda_UnlockDrive();
	void DVD_Anaconda_InjectFirmwareHack();

	void DVD_Anaconda_Delay();
	void DVD_Anaconda_Delay2();
	void DVD_Anaconda_Delay8();
	/*+----------------------------------------------------------------------------------------------+*/



#ifdef __cplusplus
}
#endif
#endif


/*
DVD INTERFACE (DI) (accessed by 32 bits)
 ------------------
		
	 address	 length  
	 --------    ------  
	 CC006000    4  	status1
		 6004    4  	status2
						  bit 29 & 30 = cover info? wr bit 1 = wait for cover? (all PPC)
		 6008    1  	command 							 
		 6009    1  	subcommand
		 600A    2  	subcommand2 				   
		 600C    4  	offset (shr 2)
		 6010    4  	source length
		 6014    4  	destination buffer
		 6018    4  	destination length
		 601C    4  	action
						   bit 0 = execute command
						   bit 1 = use destination buffer
		 6020    4  	errorcode 
		 6024    4  	config (only in lsb) (r)
	 
	 (access by word)    

	 DRIVE INFO (INQUIRY)
	 --------------------
		Command/Subcommand/Padding <- 12000000
		Offset  				   <- 0
		SLength 				   <- 20h
		Buffer  				   <- Address in ram of the buffer
		DLength 				   <- 20h
		Action  				   <- 3

		output buffer:  	  
			0000-0001  revisionLevel
			0002-0003  deviceCode 
			0004-0007  releaseDate 
			0008-001F  padding(0)
	 
	 READ
	 --------------------
		Command/Subcommand/Padding <- A8000000
		Offset  				   <- Position on DVD shr 2 
		SLength 				   <- Length of the read
		Buffer  				   <- Address in ram of the buffer
		DLength 				   <- SLength
		Action  				   <- 3
	 
	 SEEK
	 --------------------
		Command/Subcommand/Padding <- AB000000
		Offset  				   <- Position on DVD shr 2 
		Action  				   <- 1
	 
	 REQUEST ERROR
	 --------------------
		Command/Subcommand/Padding <- E0000000
		Action  				   <- 1
	 
	 AUDIOSTREAM
	 --------------------
		Command/Subcommand/Padding <- E1??0000    ?? = subcommand
		Offset  				   <- Position on DVD shr 2 
		SLength 				   <- Length of the stream
		Action  				   <- 1
	 
	 REQUEST AUDIO STATUS
	 --------------------
		Command/Subcommand/Padding <- E2000000
		Action  				   <- 1
	 
	 STOP MOTOR
	 --------------------
		Command/Subcommand/Padding <- E3000000
		Action  				   <- 1

	 DVD AUDIO DISABLE
	 --------------------     
		Command/Subcommand/Padding <- E4000000
		Action  				   <- 1
 
	 DVD AUDIO ENABLE
	 --------------------     
		Command/Subcommand/Padding <- E4010000
		Action  				   <- 1
 
	
	 ACK (???)
	 ---------
		Status2 <- Status2
		
	 INIT (???)
	 ----------
		Status1 <- 2Ah
		Status2 <- 0

	 WAIT FOR COVER CLOSE (???)
	 --------------------------
		CC006004 <- 2
		check CC006004 bits 29(ppc) et 30(ppc)     
*/

/* END OF FILE */
