

#ifndef DVD_SHRINK_H
#define DVD_SHRINK_H

// gc-shrink.h
// ackmed@gotwalls.com

//#include "zlib/zlib.h"
//#include "zlib/zutil.h"


#define RU32(x)		(x + 32 - 1) & ~(32 - 1)

#define SWAP32(x)	((((x)&0x0000FF)<<24) | (((x)&0x00FF00)<<8) | \
					(((x)&0xFF0000)>>8) | (((x)>>24)&0xFF))

#define GAMENAME_POINTER	0x20
#define	FST_POINTER		0x424
#define FST_ISDIR		0x1000000

#define TRUE			1
#define FALSE			0

#define GC_SHRINK_VERSION	0.2
#define GC_SHRINK_AUTHOR	"ackmed@gotwalls.com"




typedef struct _FST_ENTRY
{
	//do not change or add anything it needs to be 12 bytes
	unsigned int nameOffset;
	unsigned int diskAddress;
	unsigned int fileSize;
} FST_ENTRY;


typedef struct _FST_HEADER
{
	unsigned int headerOffset;
	unsigned int headerSize;

	unsigned int nameOffsetStart;
	unsigned int totalEntries;

	// pointer to the first fst_entry
	struct _FST_ENTRY* root;
} FST_HEADER;



//GZ_CHUNK_OUT is larger for room encase compression doesnt work 
#define GZ_CHUNK_IN 16384
#define GZ_CHUNK_OUT 20*1024 

/*
typedef struct _gz_stream
{
	char gzin[GZ_CHUNK_IN];
	char gzworking[GZ_CHUNK_IN];
	char gzout[GZ_CHUNK_IN];
	unsigned int gzoutavail;

	int dataInCompressionPipe;
	unsigned int exhaustedinput;
	unsigned int usedoffset;

	z_stream zipstream;
	unsigned int crc;



} gz_stream;

*/


#define DVD_SHRINK_NAMELEN 256

typedef struct _dvd_shrink
{
	//fst info
	unsigned int headerOffset;
	unsigned int headerSize;
	unsigned int nameOffsetStart;
	unsigned int totalEntries;
	unsigned int isosize;
	char gamename[DVD_SHRINK_NAMELEN];

	//streaming state vars
	unsigned int state;
	unsigned int dvd_address;
	unsigned int iso_filestart_address;
	unsigned int iso_fileend_address;
	unsigned int total_wrote;
	unsigned int current_fstentry;

	//fst interupt state
	FST_ENTRY fst_interupt_entry;
	unsigned int fst_interupt_sent;

	int gz;
	//gz_stream	gzstream;
} dvd_shrink;


void dvd_shrink_init(dvd_shrink* ds);
int dvd_shrink_read(dvd_shrink* ds, char* buffer, unsigned int len);
int dvd_shrink_readgz(dvd_shrink* ds, char* buffer, unsigned int len);




#endif





