#ifndef _ISO9660QOOB_H_
#define _ISO9660QOOB_H_

#define PAGESIZE   8

#include "types.h"
#include "color.h"

#include "video.h"

void isoHandler();
struct pvd_s
{
	char id[8];
	char system_id[32];
	char volume_id[32];
	char zero[8];
	unsigned long total_sector_le, total_sect_be;
	char zero2[32];
	unsigned long volume_set_size, volume_seq_nr;
	unsigned short sector_size_le, sector_size_be;
	unsigned long path_table_len_le, path_table_len_be;
	unsigned long path_table_le, path_table_2nd_le;
	unsigned long path_table_be, path_table_2nd_be;
	unsigned char root_direntry[34];
	char volume_set_id[128], publisher_id[128], data_preparer_id[128], application_id[128];
	char copyright_file_id[37], abstract_file_id[37], bibliographical_file_id[37];
	// some additional dates, but we don't care for them :)
}  __attribute__((packed));


struct
{
	char name[128];
	int flags;
	int sector, size;
} file[1024];

int read_sector(void* buffer, int sector);
void fatal_read_error();
int read_direntry(unsigned char* direntry);
void read_directory(int sector, int len);
void show_files(int offset, int selection);
int doiso9660();
void iso9660qoob_redraw();
void iso9660qoob_down();
void iso9660qoob_up();
int iso9660qoob_ok();

#endif
