/*
Ripped from the Qoob MP3 Player
Edited to suit our needs
- Thanks Qoob!
*/

#include "color.h"
#include "menu/draw.h"
#include "font.h"
# if defined(PSO) && defined(MOD)
#  error "cannot define both PSO and MOD"
# endif


//static unsigned char MEM_WORK[0x20000] __attribute__((aligned(32)));
//static unsigned char MEM_FONT[0x40000] __attribute__((aligned(32)));

# if defined(MOD)
#define MEM_WORK 0x800a0000
#define MEM_FONT 0x800f0000

# endif
# if defined(PSO)
#define MEM_WORK 0x81100000
#define MEM_FONT 0x81400000
# endif

extern long* fb = (void*)0xC0f00000;
#define EXI_SR  			  *(volatile unsigned long*) 0xCC006800
#define EXI_DMA_MEM 		  *(volatile unsigned long*) 0xCC006804
#define EXI_DMA_LEN 		  *(volatile unsigned long*) 0xCC006808
#define EXI_CR  			  *(volatile unsigned long*) 0xCC00680C
#define EXI_DATA			  *(volatile unsigned long*) 0xCC006810
#define EXI_WAIT_EOT		  while((EXI_CR)&1);  

//long blit_lookup[4]    ={0x258e2573, 0x6d896d77, 0xb584b57b, 0xff80ff80};
//long blit_lookup_inv[4]={0xff80ff80, 0xb584b57b, 0x6d896d77, 0x258e2573};
//long  blit_lookup[4]    ={0x00800080, 0x6d896d77, 0xb584b57b, 0xC080C080};
//long  blit_lookup_inv[4]={0xff80ff80, 0xb584b57b, 0x6d896d77, 0x00800080};
long blit_lookup[4] ={0x00800080, COLOR_WHITE, COLOR_WHITE, 0xff80ff80};
long blit_lookup_inv[4] =
{
	COLOR_BLUE, COLOR_WHITE, COLOR_WHITE, 0x00800080
};
long blit_faded[4] =
{
	COLOR_BLACK, COLOR_GRAY, COLOR_GRAY, COLOR_GRAY
};
long blit_really_faded[4] = 
{
	COLOR_BLACK, COLOR_GRAY, COLOR_GRAY, COLOR_GRAY
};
/*
Blit checking in a nice little function
*/
void blitblah(void)
{
	int p = 640 * 576 / 2;
	unsigned long* f = fb;
	while (p--)
		*f++ = blit_lookup[0];
}
/*
Named *1 due to clash with our EXI stuff
*/
void exi_select1(void)
{
	EXI_SR |= 0x150;
}

void exi_deselect1(void)
{
	EXI_SR &= ~0x100;
}

void exi_write_word(unsigned long word)
{
	EXI_DATA = word;
	EXI_CR = 0x35;
	EXI_WAIT_EOT;
}

void exi_write1(unsigned char* data, int len)
{
	while (len)
	{
		int l = len;
		if (l > 4)
			l = 4;
		EXI_DATA = *(unsigned long*)data;
		EXI_CR = 0x05 | ((l - 1) << 4);
		EXI_WAIT_EOT;

		data += l;
		len -= l;
	}
}

void exi_read1(unsigned char* dst, int len)
{
	while (len)
	{
		int l = len;
		if (l > 4)
			l = 4;
		EXI_DATA = 0;
		EXI_CR = 0x31;
		EXI_WAIT_EOT;
		*(unsigned long*)dst = EXI_DATA;
		dst += 4;
		len -= l;
	}
}

/* Yay0 decompression */
void yay0_decode(void* s, void* d)
{
	int i, j, k, p, q, cnt;

	i = *(unsigned long*)(s + 4);	  // size of decoded data
	j = *(unsigned long*)(s + 8);	  // link table
	k = *(unsigned long*)(s + 12);	 // byte chunks and count modifiers

	q = 0;					// current offset in dest buffer
	cnt = 0;				// mask bit counter
	p = 16;					// current offset in mask table

	unsigned long r22 = 0, r5;

	do
	{
		// if all bits are done, get next mask
		if (cnt == 0)
		{
			// read word from mask data block
			r22 = *(unsigned long*)(s + p);
			p += 4;
			cnt = 32;   // bit counter
		}
		// if next bit is set, chunk is non-linked
		if (r22 & 0x80000000)
		{
			// get next byte
			*(unsigned char*)(d + q) = *(unsigned char*)(s + k);
			k++, q++;
		}
		// do copy, otherwise
		else
		{
			// read 16-bit from link table
			int r26 = *(unsigned short*)(s + j);
			j += 2;
			int r25 = q - (r26 & 0xfff);
			int r30 = r26 >> 12;
			if (r30 == 0)
			{
				// get 'count' modifier
				r5 = *(unsigned char*)(s + k);
				k++;
				r30 = r5 + 18;
			}
			else
				r30 += 2;
			// do block copy
			unsigned char* pt = ((unsigned char*)d) + r25;
			int i;
			for (i = 0; i < r30; i++)
			{
				*(unsigned char*)(d + q) = *(unsigned char*)(pt - 1);
				q++, pt++;
			}
		}
		// next bit in mask
		r22 <<= 1;
		cnt--;
	}
	while (q < i);
}

/*
ipl read
*/
void ipl_read1(unsigned char* dst, int address, int len)
{
	while (len)
	{
		int l = len;
		if (l > 0x100)
			l = 0x100;

		exi_select1();
		exi_write_word(address << 6);
		exi_read1(dst, l);
		exi_deselect1();
		dst += l;
		address += l;
		len -= l;
	}
}
/*
Untile the rom font
*/
void untile(unsigned char* dst, unsigned char* src, int xres, int yres)
{
	// 8x8 tiles
	int x, y;
	int t = 0;
	for (y = 0; y < yres; y += 8)
		for (x = 0; x < xres; x += 8)
		{
			t = !t;
			int iy, ix;
			for (iy = 0; iy < 8; ++iy, src += 2)
			{
				unsigned char* d = dst + (y + iy) * xres + x;
				for (ix = 0; ix < 2; ++ix)
				{
					int v = src[ix];
					*d++ = ((v >> 6) & 3);
					*d++ = ((v >> 4) & 3);
					*d++ = ((v >> 2) & 3);
					*d++ = ((v)&3);
				}
			}
		}
}

int font_offset[256], font_size[256], font_height;

void init_font(void)
{
	ipl_read1((unsigned char*)MEM_FONT, 0x1FCF00, 0x3000);

	yay0_decode((void*)MEM_FONT, (void*)MEM_WORK);

	struct font_hdr
	{
		unsigned short font_type, first_char, last_char, subst_char, ascent_units, descent_units, widest_char_width, leading_space, cell_width, cell_height;
		unsigned long texture_size;
		unsigned short texture_format, texture_columns, texture_rows, texture_width, texture_height, offset_charwidth;
		unsigned long offset_tile, size_tile;
	} *fnt = (void*)MEM_WORK;

	untile((void*)MEM_FONT, (void*)(MEM_WORK + fnt->offset_tile), fnt->texture_width, fnt->texture_height);

	int i;
	for (i = 0; i < 256; ++i)
	{
		int c = i;
		if ((c < fnt->first_char) || (c > fnt->last_char))
			c = fnt->subst_char;
		else
			c -= fnt->first_char;

		font_size[i] = ((unsigned char*)fnt)[fnt->offset_charwidth + c];

		int r = c / fnt->texture_columns;
		c %= fnt->texture_columns; 

		font_offset[i] = (r * fnt->cell_height) * fnt->texture_width + (c * fnt->cell_width);
	}

	font_height = fnt->cell_height;
}
#define TRANSPARENCY			(0x00800080)
void blit_char(int x, int y, unsigned char c, unsigned long* lookup)
{
	unsigned char* fnt = ((unsigned char*)MEM_FONT) + font_offset[c];
	int ay, ax;
	for (ay = 0; ay < font_height; ++ay)
	{
		for (ax = 0; ax < font_size[c]; ax++)
		{
			int v0 = fnt[ax];
			unsigned long o = fb[(ay + y) * 320 + (ax + x) / 2];

			if ((ax + x) & 1)
			{
				o &= ~0x00FFFFFF;
				o |= lookup[v0] & 0x00FFFFFF;
			}
			else
			{
				o &= ~0xFF000000;
				o |= lookup[v0] & 0xFF000000;
			}
			if (lookup[v0] != TRANSPARENCY)
				fb[(ay + y) * 320 + (ax + x) / 2] = o; //libogc transperancy
		}
		fnt += 512;
	}
}

void write_font(int x, int y, const unsigned char* string)
{
	while (*string)
	{
		blit_char(x, y, *string, blit_lookup);
		x += font_size[*string];

		string++;
	}
}

void write_font_small(int x, int y, const unsigned char* string)
{
	while (*string)
	{
		blit_char(x, y, *string, blit_lookup);
		x += font_size[*string];
		x++;
		string++;
	}
	
}

void writex(int x, int y, int sx, int sy, const unsigned char* string, unsigned long* lookup)
{
	int ox = x;
	while ((*string) && ((x + 16) < (ox + sx)))
	{
		blit_char(x, y, *string, lookup);
		x += font_size[*string];

		string++;
	}

	int ay;
	for (ay = 0; ay < sy; ay++)
	{
		int ax;
		for (ax = x; ax < (ox + sx); ax += 2)
			fb[(ay + y) * 320 + ax / 2] = lookup[0];
	}
}
