#include "lwip/tcp.h"
#include <types.h>
#include <sram.h>
#include "netload.h"
#include "main.h"
#include <console.h>
#include <font.h>
#include <pad.h>
#include <menu/menu.h>
#include <menu/draw.h>

extern u32* frameBuffer;

//By CrazyShiza
int state = 0;
int dataPos[100];
char data[1000000];
int cursorPos = 1;
int maxItems = 0;
int dataLen = 0;
int dataLoc = 0;
int receiving = 0;
#define ITEMSPERSCREEN		10
#define CHRPERLINE			28

void netload_drawMenu()
{
	int start = ((cursorPos - 1) / ITEMSPERSCREEN) * ITEMSPERSCREEN;
	
	int x = 80, y = 120;
	
	clearCentre();
	write_font(x,y,"LAN Explorer:");

	int itemNum = 1;

	for (itemNum = 1; itemNum <= ITEMSPERSCREEN; itemNum++)
	{
		if (start + itemNum > maxItems)
			break;
		else if (start + itemNum == cursorPos)
			drawHighlight(frameBuffer, x-40, y+42+(26*(itemNum-1)),280);
		write_font(x,y+42+(26*(itemNum-1)),data + (start + itemNum) * (CHRPERLINE + 2) + 1);
	}
}

/*-----------------------------------------------------------------------------------*/
static void netload_conn_err(void* arg, err_t err)
{
}
/*-----------------------------------------------------------------------------------*/
static void netload_close_conn(struct tcp_pcb* pcb)
{
	tcp_arg(pcb, NULL);
	tcp_sent(pcb, NULL);
	tcp_recv(pcb, NULL);
	tcp_close(pcb);
}
/*-----------------------------------------------------------------------------------*/

static err_t netload_poll(void* arg, struct tcp_pcb* pcb)
{
	return ERR_OK;
}
/*-----------------------------------------------------------------------------------*/

static err_t netload_sent(void* arg, struct tcp_pcb* pcb, u16_t len)
{
	return ERR_OK;
}

/*-----------------------------------------------------------------------------------*/
# if defined(PSO) && defined(MOD)
#  error "cannot define both PSO and MOD"
# endif

# if defined(MOD)
#define addr		0x80C00000; //81300000 build
# endif
# if defined(PSO)
#define addr		0x81000000 //80d00000 build
# endif
static err_t netload_recv(void* arg, struct tcp_pcb* pcb, struct pbuf* p, err_t err)
{
	cursorPos = 1;
	maxItems = 0;
	int x = 0;
	char* buffer = (char*)addr;
	int len = 0;


	if (err == ERR_OK && p != NULL)
	{
		tcp_recved(pcb, p->tot_len);



		buffer = p->payload;

		if (receiving == 0)
		{
			// Inform TCP that we have taken the data.


			if (buffer[0] == 'z' || buffer[0] == 'e' || buffer[0] == 'c')
			{
				clearCentre();
				write_font(80,120, "QoobPro Flash Explorer:");
				if (buffer[0] == 'z')
					write_font(80,120 + 42,"Extraction Finished");
				else if (buffer[0] == 'e')
					write_font(80,120 + 42,"Error: File Already Exists");
				else if (buffer[0] == 'c')
					write_font(80,120 + 42,"Error: File Could Not Be Extracted");
				state = 0;
				netload_close_conn(pcb);
				return ERR_OK;
			}
			else if (buffer[0] == 'D')
			{
				clearCentre();
				write_font(80,120, "QoobPro Flash Explorer:");
				write_font(80,120 + 96, "Dol Loading...");
				netload_close_conn(pcb);
				return ERR_OK;
			}
			else
			{
				dataLoc = 0;	  
				dataLen = p->tot_len;
				for (x = 0; x < dataLen; x++)
					data[x] = buffer[x];
				dataLoc = dataLen;
				receiving = 1;
			}
		}
		else
		{
			dataLen += p->tot_len;
			len = p->tot_len;
			for (x = 0; x < len; x++)
				data[dataLoc + x] = buffer[x];
			dataLoc = dataLen;
		}
	}	


	if (p != NULL)
	{
		pbuf_free(p);
	}

	if (err == ERR_OK)
	{
		if (p == NULL)
		{
			//printf("\n");
			receiving = 0;
			maxItems = (dataLen / (CHRPERLINE + 2)) - 1;
			netload_close_conn(pcb);
			netload_drawMenu();
		}
		//else
			//printf(".");
	}

	return ERR_OK;
}
/*-----------------------------------------------------------------------------------*/
static err_t netload_accept(void* arg, struct tcp_pcb* pcb, err_t err)
{
	char message[10];	

	tcp_setprio(pcb, TCP_PRIO_MIN);

	tcp_arg(pcb, NULL);

	/* Tell TCP that we wish to be informed of incoming data by a call
		to the dolup_recv() function. */
	tcp_recv(pcb, netload_recv);
	tcp_err(pcb, netload_conn_err);
	tcp_poll(pcb, netload_poll, 4);
	tcp_sent(pcb, netload_sent);


	if (state == 0)
	{
		sprintf(message, "start%i", CHRPERLINE);
		tcp_write(pcb, message, sizeof(message), 1);
		state = 1;
	}
	else
	{
		char selection[4];

		sprintf(selection, "%i", cursorPos);

		tcp_write(pcb, selection, sizeof(selection), 1);
	}

	tcp_output(pcb);


	return ERR_OK;
}

void netload_A()
{
	clearCentre();
	
	write_font(80,120,"LAN Explorer:");
	write_font(80,120 + 42,"Loading...");

	//init
	struct tcp_pcb* pcb;			
	struct ip_addr* ipaddr = sram_get_ip(2); //, *netmask = sram_get_ip(1), *gw = sram_get_ip(0);
	pcb = tcp_new();
	tcp_connect(pcb, ipaddr, 8080, netload_accept);
	//-------------------
}

void netload_B()
{
	state = 0;
}

void netload_X()
{
	int i = 0;

	i = cursorPos;
	if (((i - 1) % ITEMSPERSCREEN) == 0)
	{
		if (i < maxItems)
			i++;
	}
	while (((i - 1) % ITEMSPERSCREEN) != 0)
		i++;
	if (i <= maxItems)
	{
		cursorPos = i;
		netload_drawMenu();
	}
}

void netload_Y()
{
	int i = 0;

	i = cursorPos;
	while ((i % ITEMSPERSCREEN) != 0)
		i--;
	if (i > 0)
	{
		cursorPos = i;
		for (i = 0; i < (ITEMSPERSCREEN - 1); i++)
			cursorPos--;
		netload_drawMenu();
	}
}

void netload_up()
{
	if (cursorPos > 1)
	{
		cursorPos--;
		netload_drawMenu();
	}
}

void netload_down()
{
	if (cursorPos < maxItems)
	{
		cursorPos++;
		netload_drawMenu();
	}
}


