/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#include "processor.h"
#include "exi.h"
#include "console.h"
#include "pad.h"
#include "video.h"
#include "color.h"
#include "time.h"
#include "sram.h"
#include <linux/string.h>
#include <dvd.h>
#include <context.h>
#include <irq.h>
#include <exception.h>
#include <cache.h>
#include "GC_Dvd.h" //emukidid
#include "asm.h"
#include "font.h"
#include "menu/menu.h"
#include "menu/draw.h"
#include <font.h>
#include <dol.h>
#include "main.h"
#include <anaconda.h>
#include <cheatgui.h>
#include <card.h>



#define IRQ_RSW				(30)
//Global Frame Buffer
u32* frameBuffer = (u32*)0xC0F00000;
static struct console_data_s console;
extern void _start(), _end();

void System_init()
{	
	int memsize = 0x1800000;	  
	// 0x80000000+n
	memset((void*)0x80000000, 0, 0x100);
	// 0..f  game-info
	strcpy((void*)0x80000000, "GPOP8P");				// PSO - could be anything.
	*(unsigned long*)0x80000008 = 1;
	*(unsigned long*)0x8000001c = 0xc2339f3d;   		// DVD magic word
	*(unsigned long*)0x80000020 = 0x0d15ea5e;   		// magic word "disease"
	*(unsigned long*)0x80000024 = 1;					// version
	*(unsigned long*)0x80000028 = memsize; 				// memory size
	*(unsigned long*)0x8000002c = 1 + ((*(unsigned long*)0xCC00302c) >> 28);
	*(unsigned long*)0x80000030 = 0;
	*(unsigned long*)0x80000034 = 0x816FFFF0;			// homebrew stuff get their SP from here... Usually set by the apploader
	*(unsigned long*)0x80000038 = 0;
	*(unsigned long*)0x8000003c = 0;
	*(unsigned long*)0x800000EC = 0x80000000 | memsize; // top of memory?
	*(unsigned long*)0x800000F0 = memsize; 				// simulated memory size
	*(unsigned long*)0x800000F4 = 0;
	*(unsigned long*)0x800000F8 = 0x09a7ec80;  			// bus speed: 162 MHz
	*(unsigned long*)0x800000FC = 0x1cf7c580;  			// cpu speed: 486 Mhz
	*(unsigned short*)0x800030e0 = 6; 					// production pads
	dcache_flush((void*)0x80000000, 0x3100);
	exi_init(); 										 //Initialize the EXI BUS for BBA/SRAM/MEMCARD ETC
	Video_Init();
	clearScreen(frameBuffer, BACKGROUND_COLOR);			 //Clear the Screen
	console_init(&console, frameBuffer, 640, 480, 640 * 2);
	ipl_set_config(2);
	init_font();										 //Initialize The Fonts from the IPL and 
	blitblah(); 										 //Get the Blit
	clearScreen(frameBuffer, BACKGROUND_COLOR);			 //Clear the Screen
}

void reset_switch()
{
	*(volatile u32*)0xCC003024 = 0x00000000;
}

int main()
{
	tb_t start, now;
	memset((void*)0x80000000, 0, ((int)_start) - 0x80000000);
	memset(_end, 0, 0x817F0000 - ((int)_end));
	dcache_flush((void*)0x80000000, 0x1800000);
	*(volatile unsigned long*)0xCC003004 = 0; //Interrupt mask
	
	System_init();
	pad_init();
	exception_init(); //Init the Exception Handler
	mftb(&start);
	mtdec(40500000);
	mtmsr(mfmsr() | 2);
	mtmsr(mfmsr() | 0x8000); // enable external (ext, dec) interrupts
	request_irq(IRQ_RSW, reset_switch, 0);//RESET SWITCH

	menu_redo(); //Draw the menu
	ANACONDA04();
	while (1) //Poll menu & listen for incoming data!
	{
		//mftb(&now);
		menuRefresh();
	}
	return 0;
}


