/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#define GCOS_VER	"GCoS Multigame"
char CubeInfoStr1[256];
char CubeInfoStr2[256];
unsigned char driveinfo[5];
char Modchip[256];
void reset_switch();
void BOOTLOAD();
void ANACONDA04();
void start_dvd_serv();
#include "ipl.h"
// ------------------------------------------------------------------------------------------
typedef volatile unsigned long* pvu32;

#define MEM32(_x)		*(pvu32)_x

#define DVD_DISR		MEM32( 0xcc006000 ) // DI Status Register
#define DVD_DICMDBUF0	MEM32( 0xcc006008 ) // DI Command Buffer 0
#define DVD_DICMDBUF1	MEM32( 0xcc00600c ) // DI Command Buffer 1
#define DVD_DICMDBUF2	MEM32( 0xcc006010 ) // DI Command Buffer 2
#define DVD_DIMAR		MEM32( 0xcc006014 ) // DI DMA Memory Address Register
#define DVD_DILENGTH	MEM32( 0xcc006018 ) // DI DMA Transfer Length Register
#define DVD_DICR		MEM32( 0xcc00601c ) // DI Control Register
#define DVD_DIIMMBUF	MEM32( 0xcc006020 ) // DI immediate data buffer (error code ?)

#define DVD_DISR_TCINT		(1 << 4)// TCINT - Transfer Complete Interrupt Status
// read : 0 Interrupt has not been requested / 1 Interrupt has been requested
// write: write 0 no effect / 1 clear Interrupt

#define DVD_DISR_DEINT		(1 << 2)// DEINT - Device Error Interrupt Status
// read : 0 Interrupt has not been requested / 1 Interrupt has been requested
// write: write 0 no effect / 1 clear Interrupt

#define DVD_DICR_DMA		(1 << 1)// DMA - 0: immediate mode, 1: DMA mode (*1)

#define DVD_DICR_TSTART		(1 << 0)// TSTART - transfer start. 
//write 1: start transfer, read 1: transfer pending

#define MACRO_DVD_CLEARSTATUS	DVD_DISR |= ( DVD_DISR_DEINT | DVD_DISR_TCINT );
#define MACRO_DVD_WAIT_STATUS	while( ! ( DVD_DISR & ( DVD_DISR_DEINT | DVD_DISR_TCINT ) ) );

#define DVD_CMD_INQUIRY		0x12000000
#define DVD_CMD_ERRSTATUS	0xE0000000
// ------------------------------------------------------------------------------------------

#define SCR_WIDTH	640
#define SCR_HEIGHT	576
#define BACKGROUND_COLOR (0x00800080) 
#define TRANSPARENCY  0 //COLOR_BLACK
#define SETTINGS_SRAM_BYTE	60   //is this byte free in sram?
