/*
	Get the time on the gamecube console - Copyright emu_kidid 2005
*/

#include "processor.h"
#include "exi.h"
#include "pad.h"
#include "ipl.h"
#include "video.h"
#include "color.h"
#include "time.h"
#include "sram.h"
#include <linux/string.h>
#include <context.h>
#include <irq.h>
#include <exception.h>
#include <cache.h>
#include "font.h"
#include "main.h"
#include "menu/draw.h"
#include <console.h>
#include <vsprintf.h>

extern u32* frameBuffer;

long sram_bias_val()
{
	unsigned long sramBuf[64];
	memcpy(&sramBuf,sram_data,64);
	return sramBuf[3];
}

long rtc_actual_tick()
{
	unsigned long val,data;
	exi_select(0, 1, 3);
	val = 0x20000000;
	exi_write(0, &val, 4);
	exi_read(0, &data, 4);
	exi_deselect(0);
	return data;
}

void write_rtc_tick(long tick)
{
	unsigned long val;
	exi_select(0, 1, 3);
	val = 0x20000000;
	exi_write(0, &val, 4);
	exi_write(0, &tick, 4);
	exi_deselect(0);
}
	
void printTime(int x, int y, long bias,int mode)
{
	int secsInDay = 0,minsInDay = 0,curHour = 0,curMin = 0,curSec = 0;
	char Time[0x20];
	char str[2];
	long actualTime = bias + rtc_actual_tick();
	
	drawFilledBox(frameBuffer, x, y, x+160, y+26, BACKGROUND_COLOR);
	// Seconds into the current day
	secsInDay = (actualTime % 86400);
	
	//Minutes into the current day
	minsInDay = secsInDay / 60;
	
	//Current Hour
	curHour = minsInDay / 60;
	if (curHour > 11)
	{
		sprintf(str,"PM");
	}
	else
		sprintf(str,"AM");
	
	//Current Minute into the hour
	curMin = minsInDay % 60;
	
	//Current Second into the minute
	curSec = secsInDay % 60;
	
	sprintf(Time,"%02d:%02d:%02d %s",curHour,curMin,curSec,str);
	
	if (mode == 1)
	{
		write_font(x,y,Time);
	}
	if (mode == 0)
	{
		set_position(x,y);
		printf("RTC Time:%s",Time);
	}
}

