/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#ifndef _DRAW_H_
#define _DRAW_H_

#include "types.h"
void clearCentre();
void drawBitmapNoDodge(u32* curFrameBuffer, const unsigned long* image, int scrX, int scrY, int w, int h);
void drawGradient(u32* curFrameBuffer, int sx, int sy, int endX);
void drawBitmapDodge(u32* curFrameBuffer, const unsigned long* image, int scrX, int scrY, int w, int h,u32 col);
void drawHighlight(u32* curFrameBuffer, int sx, int sy,int endX);
void menuDrawPic(u32* curFrameBuffer, int scrX, int scrY,  int iZoom);
void menuDrawPicClip(u32* curFrameBuffer, int scrX, int scrY, int bufX, int bufY, int w, int h, int iZoom);
void DrawCircle(u32* curFrameBuffer, int xCenter, int yCenter, int radius, u32 Color);
void drawFilledBox(u32* dst, s32 x1, s32 y1, s32 x2, s32 y2, u32 color);
void drawFilledBoxWeak(u32* dst, s32 x1, s32 y1, s32 x2, s32 y2, u32 color);
void DecompressRLEs(); 
void DecompressRLE2();
void fadeScreenArea(u32* curFrameBuffer, s32 x1, s32 y1, s32 x2, s32 y2, u32 Color);
void DecompressRLE(const unsigned long* pSouce, u32* pDest, int iSize); 
void menuDrawLogo(u32* curFrameBuffer, int scrX, int scrY, int iZoom);
void menuDrawLogoClip(u32* curFrameBuffer, int scrX, int scrY, int bufX, int bufY, int w, int h, int iZoom);
void fadeScreen(u32* frameBuffer, u32 Color,int timeToFade);
void menuDrawSelect(u32* curFrameBuffer, int scrX, int scrY);
void drawBitmap(u32* curFrameBuffer, const unsigned long* image, int scrX, int scrY, int w, int h);
void menuDrawHLine(u32* curFrameBuffer, int x1, int x2, int y, u32 color);
void menuDrawVLine(u32* curFrameBuffer, int x, int y1, int y2, u32 color);
void menuDrawBox(u32* curFrameBuffer, int x1, int y1, int x2, int y2, u32 color);
void drawBitmapInv(u32* curFrameBuffer, const unsigned long* image, int scrX, int scrY, int w, int h);
void menuDrawInnerMenu(u32* curFrameBuffer, bool bClipped);
void menuDrawHelpMenu(u32* curFrameBuffer, bool bClipped);

void clearScreen(u32* curFrameBuffer, u32 Color);

void menuDrawBanner(u32 *curFrameBuffer,u32 *banner ,int scrX, int scrY, int iZoom);
#endif
