/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include "MENU.h" 
#include "pad.h"
#include "font.h"
#include "sram.h"
#include <dvd.h>
#include "console.h"
#include "main.h"
#include "draw.h"
#include "GC_dvd.h"
#include "dol.h" 
#include <irq.h>
#include "iso9660qoob.h"
#include <linux/string.h>
#include <console.h>
#include <processor.h>
#include <exception.h>
#include <types.h>
#include "memlayout.h"
#include <GC_Time.h>

#include <anaconda.h>
#include <menu/pic.h>
#include <patcher.h>
#include <setupdrive.h>
#include <qoob.h>
extern u32* frameBuffer;

int ID;
int status;
int menu_hilight = -1;
int lock_menu = 0;
//Global Menu variables
int iMenuCurrentLevel = 0;
int menu_current = 0;
int menu_redraw = 1;
int waitrelease = 0;

PAD pad;

struct menuentry_s
{
	const char* text;
	const char* value;
	void (*handler)(struct menuentry_s*, int event, int data);
	int data;
	int iLevel;
	int iPos;
	int iParentMenu;
	char temp[30];
} menu[] =
{
	//   text, 			  value, handler,     		data, level, pos  parent
	{"Boot DVD",   	   	      0, menu_boot_backup,   0, 	0,   0,	 0},
    {"Credits",				  0, menu_credits,		 0,		0,	 1,  0},
	
    //Terminating entry
    {0,0,0,0, -1,0,0}
};



void menu_boot_backup(struct menuentry_s* entry, int event, int data)
{
	if ((event == EVENT_BUTTON) && (data == BUTTON_A))
	{

		int x = 100;
		int y = 170;
		clearCentre();
		PAD PAD;
		write_font(x, y, "Place a Disc in the Drive");
		write_font(x, y+26, "Press A to start the process...");
		//The user must have release the button before a new read.
		do
		{
			PAD_ReadState(&PAD, 0);
		}
		while (PAD.Digital.A);
		while (1)
		{
			PAD_ReadState(&PAD, 0);
			if (PAD.Digital.A)
			{
				do{PAD_ReadState(&PAD, 0);}while(PAD.Digital.A);
				video_wait_vsync(); 
				clearCentre();
				ANACONDA04();
				menu_redo();
				break;
			}
			else if (PAD.Digital.B)
			{
				clearCentre();
				break;
			}
		}

	}
}


void menu_credits(struct menuentry_s* entry, int event, int data)
{
	if ((event == EVENT_BUTTON) && (data == BUTTON_A))
	{
		clearCentre();
		do
		{
			PAD_ReadState(&pad, 0);
		}
		while (pad.Digital.A);

		char Text[] = 
		"               CREDITS\n"
		"      GCoS MultiGame DVD9 GC/Wii\n\n"
		"- The Team:\n"
		"    Main coder\n"
		"         emu_kidid\n"
		"    BNR2YcbYcr\n"
		"         Maximilianop\n"
		"    MIA Coders\n"
		"         ShadowSan\n"
		"         Vtrucco\n"
		"    Website Admin\n"
		"         Hatrix\n"
		"- Greets to:\n"
		"         Boss351, Brakken,\n"
		"         Shagkur, Softdev,\n"
		"         tmbinc, Dr_Matrix,\n"
		"         Cortex, Rodimus,\n"
		"         Honkeykong, cReDiAr,\n"
		"         Ravin, Prime_NL,\n"
		"         PiXel8, Lukeage,\n"
		"         Znomore, DarkwingD,\n"
		"         DarkAkuma, k-0-d,\n"
		"         Fuzziqer_Software, Plug,\n"
		"         Xboxmodder999, QoobTeam,\n"
		"         MentalCube, Freefall,\n"
		"         Wildlight, ttl, xor37h\n"
		"         Cheqmate, GC-linux,\n"
		"         isobel, VTrucco,\n"
		"         or9, Yackom,\n"
		"         and anyone I missed.\n"
		"- Visit us at:\n"
		"         and #tehskeen EFNet\n\n"
		"- Visit WiiNewz at:\n"
		"         www.wiinewz.com\n"
		"  RIP tehskeen 8-6-07\n\n"
        "\n"
        "\n"
        "GPL License\n"
		"This program is free software\n"
		"you can redistribute it and/or\n"
		"modify it under the terms of the\n"
		"GNU General Public License as\n"
		"published by the Free Software \n"
		"Foundation; either version 2 of\n"
		"the License, or (at your option)\n"
		"any later version.\n\n"
		"This program is distributed in\n"
		"the hope that it will be useful,\n"
		"but WITHOUT ANY WARRANTY; without\n"
		"even the implied warranty of\n"
		"MERCHANTABILITY or FITNESS FOR A\n"
		"PARTICULAR PURPOSE.  See the GNU \n"
		"General Public License for more\n"
		"details.\n\n"
		"You should have received a copy of\n"
		"the GNU General Public License along\n"
		"with this program; if not, write to\n"
		"the Free Software Foundation, Inc.,\n"
		"59 Temple Place, Suite 330, Boston,\n"
		"MA 02111-1307 USA\n"
		;
	clearCentre();
	ScrollBox(85, 130, 9, 0, Text);
	while (1)
		{
			PAD_ReadState(&pad, 0); 
			if (pad.Digital.Up || (pad.Analog.Y < -50))
			{
			    clearCentre();
                ScrollBox(85, 130, 9, -1, Text);
				GC_Sleep(35);
			}
			else if (pad.Digital.Down || (pad.Analog.Y > 50))
			{
			    clearCentre();
			    ScrollBox(85, 130, 9, 1, Text);
				GC_Sleep(35);
			}
			else if (pad.Digital.B)
			{
				clearCentre();
				break;
			}	
		}
	}
}

void ScrollBox (int iX, int iY, int iLines, int iOffset, char *Text)
{
	static int iStartLine=0;
	char *textDup;
	strcpy(textDup, Text);
	
	char *tokenPtr;
		
	tokenPtr = strtok (textDup, "\n");

	if (iOffset==0)
		iStartLine=0; //reset the scroll
	else
		iStartLine+=iOffset;

	if (iStartLine<0) iStartLine=0;

	int i=0; 
	set_color(BACKGROUND_COLOR, COLOR_YELLOW);
	while ((tokenPtr!=NULL) && (i<iStartLine+iLines))
	{
		if (iStartLine<=i)
		{
			write_font(iX, iY,tokenPtr);
			iY+=28;
			
		}
		i++;

		tokenPtr = strtok(NULL,"\n");

	}
	
	set_color(BACKGROUND_COLOR, COLOR_SKYBLUE);	
	if (iStartLine>0)
	{
		set_position(550, 160); printf ( "%c", 169 ); //UP ARROW
	}
	if (i>=iStartLine+iLines) {
		set_position(550, 380); printf ( "%c", 170 ); //DOWN ARROW 
		
	}
	else
	iStartLine--;			

	return;
}


void menu_level(struct menuentry_s* entry, int event, int data)
{
	if ((event == EVENT_BUTTON) && (data == BUTTON_A))
	{
		iMenuCurrentLevel = entry->data;

		//select the first entry in new menu
		int current = 0;
		while (1)
		{
			if (menu[current].iLevel == iMenuCurrentLevel)
			{
				menu_current = current;
				break;
			}
			current++;
		}		

		PAD PAD;
		//The user must have release the button before a new read.
		do
		{
			PAD_ReadState(&PAD, 0);
		}
		while (PAD.Digital.A);
	}
}


void menu_redo()
{
	clearScreen(frameBuffer, BACKGROUND_COLOR);
	int i = 0;
	set_color(BACKGROUND_COLOR, COLOR_SKYBLUE);	

	drawBitmapDodge(frameBuffer, background, 25, 30, 540, 450,COLOR_WHITE);
	clearCentre();
	write_font(120, 120, "MAIN MENU");
	write_font(310, 35, "MultiGame DVD9 Ver");
	
	set_position(70,461); 
	printf("%s -DI:%08x",CubeInfoStr1,drive_version());

}



void centre_redo()
{
	clearCentre();
//	drawBitmapNoDodge(frameBuffer, wiinjalogo_Bitmap, 150, 110, WIINJALOGO_WIDTH, WIINJALOGO_HEIGHT);
	write_font(120, 120, "MAIN MENU");
}

void drawBG()
{
	drawBitmapDodge(frameBuffer, background, 25, 30, 540, 450,COLOR_WHITE);
}


void menuRefresh(void)
{
	int a;
	int hi;
	int isup = 0, isdown = 0, isleft = 0, isright = 0;
	if (menu_redraw && !lock_menu)
	{
		struct menuentry_s* m = menu;
		int x = 120;
		int y = 170;
		int i = 0;
		centre_redo();
		
		while (m->handler)
		{
			//Show only the sub-menu selected
			if (m->iLevel != iMenuCurrentLevel)
			{
				m++;
				i++;
				continue;
			}
			m->handler(m, EVENT_REDRAW, 0);		
			if ((i == menu_current) && (menu_hilight == -1))
			{
			   	drawHighlight(frameBuffer, 55, y+3,(strlen(m->text)*16));
				write_font(x,y,m->text);
			}
			else
			if ((i == menu_current) && (menu_hilight >= 0))
			{
				int l = m->value ? strlen(m->value) : 0;
				set_position(125, 175 + (m->iPos * 26)); //FOR THE IP'S!
				for (a = 0; a < l; ++a)// IPS happen here, MESSY!
				{
					hi = (a == menu_hilight) && (i == menu_current);
					putchar(m->value[a]);
				}
				
			}
			else
			{
				write_font(x, y, m->text);
			}
			y += 26;
			++m; ++i;
		}
		menu_redraw = 0;
	}

	PAD_ReadState(&pad, 0);



	if (pad.Digital.Up || (pad.Analog.Y < -50))
		isup = 1;
	if (pad.Digital.Down || (pad.Analog.Y > 50))
		isdown = 1;

	if (pad.Digital.Left || (pad.Analog.X < -50))
		isleft = 1;
	if (pad.Digital.Right || (pad.Analog.X > 50))
		isright = 1;

	if (pad.Digital.A && (!waitrelease))
	{
		menu[menu_current].handler(menu + menu_current, EVENT_BUTTON, BUTTON_A);
		menu_redraw = 1;
		waitrelease = 1;
	}

	if (pad.Digital.B && (!waitrelease))
	{
		if (menu_hilight == -1)
		{
			//only if we are in a sub menu
			if (iMenuCurrentLevel)
			{
				iMenuCurrentLevel = menu[menu_current].iParentMenu;

				//select the first entry in main menu
				int current = 0;
				while (1)
				{
					if (menu[current].iLevel == iMenuCurrentLevel)
					{
						menu_current = current;
						break;
					}
					current++;
				}		

				menu_redraw = 1;
				waitrelease = 1;
			}
		}
	}


	if (isleft && !waitrelease)
	{
		menu[menu_current].handler(menu + menu_current, EVENT_BUTTON, BUTTON_LEFT);
		waitrelease = 1;
		menu_redraw = 1;
	}

	if (isright && !waitrelease)
	{
		menu[menu_current].handler(menu + menu_current, EVENT_BUTTON, BUTTON_RIGHT);
		waitrelease = 1;
		menu_redraw = 1;
	}

	if (isup && !waitrelease)
	{
		if (menu_hilight == -1)
		{
			menu_current--;

			if (menu_current < 0)
			{
				//ugly hack... FIX ME
				menu_current = 1; //must be the number of last menu option

				//or jumps to end
				while (menu[menu_current].iLevel != iMenuCurrentLevel)
				{
					menu_current--;
				}
			}

			//Jump to an item in the same sub level
			while (menu[menu_current].iLevel != iMenuCurrentLevel)
			{
				menu_current--;

				if (menu_current < 0)
				{
					//ugly hack... FIX ME
					menu_current = 1; //must be the number of last menu option

					//or jumps to end
					while (menu[menu_current].iLevel != iMenuCurrentLevel)
					{
						menu_current--;
					}
					break;
				}
			}
		}
		else
			menu[menu_current].handler(menu + menu_current, EVENT_BUTTON, BUTTON_UP);

		menu_redraw = 1;
		waitrelease = 1;
	}
	if (isdown && !waitrelease)
	{
		if (menu_hilight == -1)
		{
			//Jump to an item in the same sub level
			while (menu[++menu_current].iLevel != iMenuCurrentLevel)
			{
				if (!menu[menu_current].handler)
				{
					//select the first entry in current menu
					int current = 0;
					while (1)
					{
						if (menu[current].iLevel == iMenuCurrentLevel)
						{
							menu_current = current;
							break;
						}
						current++;
					}		
					break;
				}
			}
		}
		else
			menu[menu_current].handler(menu + menu_current, EVENT_BUTTON, BUTTON_DOWN);

		menu_redraw = 1;
		waitrelease = 1;
	}
	if (!(isup || isdown || isleft || isright || pad.Digital.A || pad.Digital.B))
		waitrelease = 0;

}

