/****************************************************************************
* libogc - DVD Demo
*
* Demonstrates reading a sector from DVD
****************************************************************************/
#include <stdio.h>
#include <gccore.h>		/*** Wrapper to include common libogc headers ***/
#include <ogcsys.h>		/*** Needed for console support ***/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dol.h"

#define mfmsr()   ({unsigned int rval; \
      asm volatile("mfmsr %0" : "=r" (rval)); rval;})
#define mtmsr(v)  asm volatile("mtmsr %0" : : "r" (v))

void load_dol(void* dol, int size)
{
	void (*entrypoint)();

		struct dol_s
		{
			unsigned long sec_pos[18];
			unsigned long sec_address[18];
			unsigned long sec_size[18];
			unsigned long bss_address, bss_size, entry_point;
		} *d = (struct dol_s *)dol;
		int i;

		for (i = 0; i < 18; ++i)
		{
			if (!d->sec_size[i])
				continue;
			memcpy((void*)d->sec_address[i], ((unsigned char*)dol) + d->sec_pos[i], d->sec_size[i]);
		}

		memset((void*)d->bss_address, 0, d->bss_size);
		entrypoint = (void(*)())d->entry_point;

	mtmsr((mfmsr() | 2) & ~0x8000);

	DCFlushRange((void*)0x80000000, 0x1800000);
	SYS_ResetSystem(SYS_SHUTDOWN, 0, 0);
	entrypoint();
	while (1);
}

int main ()
{
	VIDEO_Init ();
	load_dol(DOL,DOL_LEN);
    return 0;
}
